#ifndef ___FASTML____H
#define ___FASTML____H

#include "alphabet.h"
#include "definitions.h"
#include "fastml_options.h"
#include "sequenceContainer1G.h"
#include "stochasticProcess.h"
#include "suffStatComponent.h"
#include "treeInterface.h"
using namespace treeInterface;


class fastml {

public:
	explicit fastml(int argc, char* argv[]);
	virtual ~fastml() { delete _alph; delete _sp; delete _options;}
private:
	sequenceContainer1G _sc;
	tree _t1;
	stochasticProcess* _sp;

	void getStartingStochasticProcess();
	void getStartingEvolTree();

	void printFASTMLInfo(ostream& out);
	void fillOptionsParameters(int argc, char* argv[]);
	const fastmlOptions* _options;
	void printOptionParameters();
	void getStartingSequenceData();
	alphabet* _alph;

	void getStartingTreeFromTreeFile();
	void outputTreeFileInPHYLIPFormatToAFile();
	void outputTreeFileInAncestorFormatToAFile();
	void computeJointReconstruction();
	void computeMarginalReconstruction();

	void outputTheJointProbAtEachSite(const vector<MDOUBLE> & jointLikelihoodOfPositions);
	void outputTheJointReconstruction(const sequenceContainer1G& withAncestral);
	sequenceContainer1G getJointReconstruction(const vector<string> & ancestralSequences);
	void outputTheMarginalProbAtEachSite(const vector<MDOUBLE> &  marginalLikelihoodOfPositions);
	void outputTheMarginalProbForEachCharForEachNode(const suffStatGlobalHomPos & sscMarginal,
		const int pos);//(DEFAULT = JPF, same file as above).
	sequenceContainer1G getMarginalReconstruction(const vector<string> & ancestralSequences);
	void outputTheMarginalReconstruction(const sequenceContainer1G& withAncestral);//DEFAULT = MDP
	void getStartingNJtreeNjJC(); // same function as in rate4site.
	void getStartingTreeNJ_fromDistances(const VVdouble& disTab,
						const vector<string>& vNames);// same function as in rate4site.
	
};


#endif
