#if !defined ___FASTML__OPTION__T__
#define ___FASTML__OPTION__T__

#ifndef __STDC__
#define __STDC__ 1
#include "getopt.h"
#undef __STDC__
#else
#include "getopt.h"
#endif

#include <string>
#include <fstream>
using namespace std;

class fastmlOptions{
public:
	string treefile;
	string seqfile;
	string logFile;
	int logValue;
	
	// output files
    //THE TREE:
	string outFile_pin;	 // phylip tree file format with internal nodes lables
	string outFile_fin;	 // FASTML tree file format with internal nodes lables
	//JOINT:
	string outFile_jrof; //joint reconstruction output file
	string outFile_jpf;	 // joint probability of each position file
	//MARGINAL
	string outFile_mrof; //marginal reconstruction output file
	string outFile_mdp; //marginal detailed probabilities (each node, each char)



	enum SeqFileFormat {mase,clustal,fasta,molphy,phylip};
	SeqFileFormat seqInputFormat;
	SeqFileFormat seqOutputFormat;
	
	enum modelNameType {rev,jtt,day,aajc,nucjc,wag,cprev};
	modelNameType modelName;
	
	int alphabet_size;
	enum distributionNameType {hom,gam};// new
	distributionNameType distributionName; // new

	enum treeSearchAlgType {njJC,njML,MLfromManyNJ,njJCOLD};
	treeSearchAlgType treeSearchAlg;

//  unsigned long randseed;
	bool removeGaps;
	enum bblOptionType {non, ml, ml_gam};
	bblOptionType bblOption;

private:
  ostream* outPtr;
  ofstream out_f;
public:
  ostream& out() const {
	  return *outPtr;
  };
  explicit fastmlOptions(int& argc, char *argv[]);
};


#endif
